from django.db import models
from datetime import *
'''
De un Autor nos interesa recoger sus datos personales, esto es,
nombre, sus apellidos (por separado), su direccion de correo
electronico, su pagina web, y aniadiremos unos cuantos campos para
nosotros, como por ejemplo un booleano para saber si ha pagado o
no, y otro que nos confirme su asistencia.
Puesto que un Autor puede escribir varios articulos, y un
articulo puede ser escrito por varios autores, aniadiremos un campo
de relacion ManyToMany con el modelo Articulo que describiremos a
continuacion.
CH_POSTER = ( ('orl','Orl'),('poster','Poster') )
'''
class Nivel (models.Model):
	''' por definir....'''
		nombre = models.CharField(maxlength=32)
		class Admin:pass
		def __str__(self):
			return self.nombre
TIPOS_CLASE = ( ('M','Magia'),('B','Bruta') )
TIPOS_ESTADO= (('V','Vivo'),)('M','Muerto'),('C','Combate'))
TIPOS_ACCION = (('P','Pendiente revision'),('A','Aceptado'),('R','Rechazado'))
class Articulo(models.Model):	
	titulo      = models.CharField(maxlength=100)
	abstract    = models.TextField()
	fichero     = models.FileField(upload_to='/home/juax/media/documentos/')
	accion      = models.CharField(maxlength=1, choices=TIPOS_ACCION)
	clase       = models.CharField(maxlength=1, choices=TIPOS_CLASE)
	publicacion = models.DateTimeField()
	nivel       = models.ForeignKey(Nivel) #models.ManyToManyField(Nivel)	
	motivo_rechazo = models.CharField(maxlength=100)
	class Admin:
		list_display = ('titulo',
			'publicado_hace_menos_de_una_semana')
	def __str__(self): #Metodo 'magico' para representar la clase como una cadena
		return self.titulo
	def publicado_hace_menos_de_una_semana(self): #para comparar fechas se usa datetime
		return self.publicacion + timedelta(7)>=datetime.now()
class Autor(models.Model):
	nombre = models.CharField(maxlength=32)
	apellido1 = models.CharField(maxlength=50)
	apellido2 = models.CharField(maxlength=50)	
	articulos = models.ManyToManyField(Articulo)
	pagado    = models.BooleanField(default=False)
	asistencia= models.BooleanField(default=False)
	email = models.EmailField()
	#web   = models.URLField(Blank=True)
	class Admin:pass
	def __str__(self):#Metodo 'magico' para representar la clase como una cadena
		return self.nombre+" "+self.apellido1+" "+self.apellido2