from django.template import Context,loader
from django.http import HttpResponse
from django.shortcuts import render_to_response
from juego.portal.models import *
from django.conf import settings
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import user_passes_test
def esta_conectado(request):
	if request.user.is_authenticated():
		conectado = "Conectado como "+request.user.username+'. <a href="/juego/logout/">desconectar</a>'
	else:
		conectado = 'Usuario no identificado. <a href="/juego/login/">Login</a>'
	return conectado
def insertar_jugador(request):
	from django.forms import FormWrapper
	manip = Jugador.AddManipulator()
	if request.POST:
		post_data = request.POST.copy()
		errores = manip.get_validation_errors(post_data)
		if not errores:
			manip.do_html2python(post_data)
			nuevo_jugador = manip.save(post_data)
			return HttpResponseRedirect("/juego/")
	else:
		errores = {}
		post_data = manip.flatten_data()
	form = FormWrapper(manip, post_data, errores,edit_inline=True)
	return render_to_response('insertar_jugador.html',{'form': form,'conectado':esta_conectado(request),})
insertar_jugador=user_passes_test(lambda u:u.is_authenticated(),login_url='/juego/login/')(insertar_jugador)

def index(request):
	colonias_portada = Colonia.objects.order_by('-publicacion') #- == DESC
	t = loader.get_template('portada.html')
	c = Context({'colonias_portada': colonias_portada,
		'titulo': 'Bienvenid@ a la lista de art&iacute;culos del juego',
		'texto_intro_preambulo1':'Listado de art&iacute;culos de todos los jugadores',
		'texto_intro_preambulo2':'Se muestran a continuaci&oacute;n los t&iacute;tulos',
		'texto_preambulo':'Cliquee sobre el t&iacute;tulo del art&iacute;culo para visualizarlo completo o sobre el nombre del jugador para ver los datos y sus art&iacute;culos',
		'titulo_contenido':'Listado de art&iacute;culos',
		'conectado':esta_conectado(request),
		'estilos':'',
		'scripts':'',
		'base':settings.MEDIA_URL,
		})
	return HttpResponse(t.render(c))

def menu_jugador(request,id_jugador):
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	t = loader.get_template('ver_jugador.html')
	c = Context({ 'id_jugador':id_jugador,
		'jugador': jugador,
		'estilos':'',
		'conectado':esta_conectado(request),
		'scripts':'',		
		})
	#manip = Jugador.AddManipulator()
	
	return HttpResponse(t.render(c))

def ver_colonias(request,id_jugador):
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	t = loader.get_template('ver_colonias.html')
	c = Context({ 'id_jugador':id_jugador,
		'jugador': jugador,
		'estilos':'',
		'conectado':esta_conectado(request),
		'scripts':'',		
		})
	#manip = Jugador.AddManipulator()
	
	return HttpResponse(t.render(c))
	
	
def ver_colonia(request,id_jugador,id_colonia):
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	
	try:
		colonia = Colonia.objects.get(jugador__id=id_jugador,pk=id_colonia)
		t = loader.get_template('ver_colonia.html')
		c = Context({ 'id_jugador':id_jugador,
		'jugador': jugador,
		'colonia':colonia,
		'conectado':esta_conectado(request),
		'estilos':'',
		'scripts':'',		
		})
	except:
		t = loader.get_template('error_colonias.html')
		c = Context({ 'id_jugador':id_jugador,
		'jugador': jugador,
		'colonia':None,
		'conectado':esta_conectado(request),
		'estilos':'',
		'scripts':'',		
		})
	#manip = Jugador.AddManipulator()	
	return HttpResponse(t.render(c))
def editar_colonia(request,id_jugador,id_colonia):
	from django.forms import FormWrapper
	jugador = Jugador.objects.get(pk=id_jugador)
	colonia = Colonia.objects.get(jugador__id=id_jugador,pk=id_colonia)
	manip = Colonia.ChangeManipulator(id_colonia)
	if request.POST:
		post_data = request.POST.copy()
		post_data.update(request.FILES)
		errores = manip.get_validation_errors(post_data)
		if not errores:
			manip.do_html2python(post_data)
			nuevo_colonia = manip.save(post_data)
			return HttpResponseRedirect("/juego/")
	else:
		errores = {}
		'''post_data = {'titulo': colonia.titulo,
			'abstract': colonia.abstract, 
			'fichero': colonia.fichero, 'presentacion': colonia.presentacion, 
			'estado': colonia.estado,'nivel':colonia.nivel, 'id': id_colonia}
			'''
		post_data = manip.flatten_data()
	form = FormWrapper(manip, post_data, errores,edit_inline=True)
	return render_to_response('editar_colonia.html',{'form': form,'id_jugador':id_jugador,'jugador':jugador,'colonia':colonia,'post_data':post_data, 'conectado':esta_conectado(request),})
editar_colonia=user_passes_test(lambda u:u.is_authenticated(),login_url='/juego/login/')(editar_colonia)
def nivels(request):
	nivels = Nivel.objects.order_by('nombre')
	return render_to_response('nivels.html',{'nivels':nivels,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/javascript" src="/media/js/asistencias.js"></script>'
	})
def correcciones(request,id_nivel):
	from django.forms import FormWrapper	
	colonias = Colonia.objects.get(nivels_id=id_nivel)
	manip = Colonia.ChangeManipulator(id_colonia)
	if request.POST:
		post_data = request.POST.copy()
		post_data.update(request.FILES)
		errores = manip.get_validation_errors(post_data)
		if not errores:
			manip.do_html2python(post_data)
			nuevo_colonia = manip.save(post_data)
			return HttpResponseRedirect("/juego/")
	else:
		errores = {}
		'''post_data = {'titulo': colonia.titulo,
			'abstract': colonia.abstract, 
			'fichero': colonia.fichero, 'presentacion': colonia.presentacion, 
			'estado': colonia.estado,'nivel':colonia.nivel, 'id': id_colonia}
			'''
		post_data = manip.flatten_data()
	form = FormWrapper(manip, post_data, errores,edit_inline=True)
	return render_to_response('editar_colonia.html',{'form': form,'id_jugador':id_jugador,'jugador':jugador,'colonia':colonia,'post_data':post_data, 'conectado':esta_conectado(request),})
correcciones=user_passes_test(lambda u:u.is_authenticated(),login_url='/juego/login/')(correcciones)
def aceptar_correccion(request,id_nivel):
	pass
def rechazar_correccion(request,id_nivel):
	pass
def insertar_colonia(request,id_jugador):
	from django.forms import FormWrapper
	jugador = Jugador.objects.get(pk=id_jugador)	
	manip = Colonia.AddManipulator()
	if request.POST:
		post_data = request.POST.copy()
		errores = manip.get_validation_errors(post_data)
		if not errores:
			manip.do_html2python(post_data)
			nuevo_colonia = manip.save(post_data)
			return HttpResponseRedirect("/juego/")
	else:
		errores = {}
		post_data = manip.flatten_data()
	form = FormWrapper(manip, post_data, errores,edit_inline=True)
	return render_to_response('insertar_colonia.html',{'form': form,'id_jugador':id_jugador,'jugador':jugador, 'conectado':esta_conectado(request),})
insertar_colonia=user_passes_test(lambda u:u.is_authenticated(),login_url='/juego/login/')(insertar_colonia)

'''
--------------VISTAS AJAX---------
'''
def ver_colonias_ajax(request):
	jugadores = Jugador.objects.order_by('nombre')
	#colonias_portada = Colonia.objects.order_by('-publicacion') #- == DESC
	t = loader.get_template('datos.html')
	c = Context({'jugadores': jugadores,})
	return HttpResponse(t.render(c))
def accions(request):
	jugadores = Jugador.objects.order_by('nombre')
	return render_to_response('accions.html',{'jugadores':jugadores,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/javascript" src="/media/js/accions.js"></script>'
	})
def confirmar_accions(request,id_jugador):
	jugadores = Jugador.objects.order_by('nombre')
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	try:
		jugador.pagado = True
		jugador.save()
		mensaje = 'Se ha confirmado el accion para este jugador'
	except:	
		mensaje = 'No se ha podido confirmar el accion para este jugador'
	return render_to_response('confirma_accion.html',{'jugadores':jugadores,
	'jugador':jugador,
	'mensaje':mensaje,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/script" src="/media/js/accions.js"></script>'
	})
def rechazar_accions(request,id_jugador):
	jugadores = Jugador.objects.order_by('nombre')
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	try:
		jugador.pagado = False
		jugador.save()
		mensaje = 'Se ha rechazado el accion para este jugador'
	except:	
		mensaje = 'No se ha podido rechazar  el accion para este jugador'
	return render_to_response('confirma_accion.html',{'jugadores':jugadores,
	'jugador':jugador,
	'mensaje':mensaje,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/script" src="/media/js/accions.js"></script>'
	})
def asistencias(request):
	jugadores = Jugador.objects.order_by('nombre')
	return render_to_response('asistencia.html',{'jugadores':jugadores,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/javascript" src="/media/js/asistencias.js"></script>'
	})
def confirmar_asistencias(request,id_jugador):
	jugadores = Jugador.objects.order_by('nombre')
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	try:
		jugador.asistencia = True
		jugador.save()
		mensaje = 'Se ha confirmado el accion para este jugador'
	except:	
		mensaje = 'No se ha podido confirmar la asistencia para este jugador'
	return render_to_response('confirma_accion.html',{'jugadores':jugadores,
	'jugador':jugador,
	'mensaje':mensaje,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/script" src="/media/js/asistencias.js"></script>'
	})
def rechazar_asistencias(request,id_jugador):
	jugadores = Jugador.objects.order_by('nombre')
	jugador = Jugador.objects.get(pk=id_jugador) #Where primary key pk=id_jugador
	try:
		jugador.asistencia = False
		jugador.save()
		mensaje = 'Se ha rechazado la asistencia para este jugador'
	except:	
		mensaje = 'No se ha podido rechazar  el accion para este jugador'
	return render_to_response('confirma_accion.html',{'jugadores':jugadores,
	'jugador':jugador,
	'mensaje':mensaje,
	'conectado':esta_conectado(request),
	'scripts':'<script type="text/script" src="/media/js/asistencias.js"></script>'
	})
def login(request):
	"Muestra el formulario de login y maneja las acciones de su interaccion."
	from django.contrib.auth.forms import AuthenticationForm
	from django.contrib.auth import LOGIN_URL, REDIRECT_FIELD_NAME
	from django.forms import FormWrapper
	from django.contrib.sites.models import Site
	from django.template import RequestContext
	
	manipulator = AuthenticationForm(request)
    	redirect_to = request.REQUEST.get(REDIRECT_FIELD_NAME, '')
	if request.user.is_authenticated():
		formulario = 'logout_sal.html'
	else:
		formulario = 'login_form.html'
    	if request.POST:
        	errors = manipulator.get_validation_errors(request.POST)
        	if not errors:
            	# Comprobar seguridad: es basura?
            		if not redirect_to or '://' in redirect_to or ' ' in redirect_to:
                		redirect_to = '/juego/'
            		from django.contrib.auth import login
            		login(request, manipulator.get_user())
            		request.session.delete_test_cookie()
            		return HttpResponseRedirect(redirect_to)
    	else:
        	errors = {}
    	request.session.set_test_cookie()	
    	return render_to_response(formulario, {
        	'form': FormWrapper(manipulator, request.POST, errors),
		'conectado':esta_conectado(request),
        	REDIRECT_FIELD_NAME: redirect_to,
        	'site_name': Site.objects.get_current().name,
    	}, context_instance=RequestContext(request))
def logout(request, next_page=None, template_name='desconectado.html'):
    "Hace que el usuario se desconecte y muestra el mensaje."
    from django.contrib.auth import logout
    from django.template import RequestContext
    logout(request)
    if next_page is None:
        return render_to_response(template_name, {'mensaje': _('Desconectado'),'conectado':esta_conectado(request),}, context_instance=RequestContext(request))
    else:
        return HttpResponseRedirect(next_page or request.path)