from django.db import models
from datetime import *
class Etiqueta (models.Model):
		nombre = models.CharField(maxlength=32)
		class Admin:pass
		def __str__(self):
			return self.nombre

class Articulo(models.Model):
	titulo = models.CharField(maxlength=100)
	texto  = models.TextField()
	email  = models.EmailField()
	site   = models.URLField(blank=True,)
	publicacion = models.DateTimeField()
	etiquetas   = models.ManyToManyField(Etiqueta)
	class Admin:
		list_display = ('titulo',
			'publicado_hace_menos_de_una_semana')
	def __str__(self): #Metodo 'magico' para representar la clase como una cadena
		return self.titulo
	def publicado_hace_menos_de_una_semana(self): #para comparar fechas se usa datetime
		return self.publicacion + timedelta(7)>=datetime.now()
class Comentario(models.Model):
	autor = models.CharField(maxlength=32)
	email = models.EmailField()
	site  = models.URLField()
	texto = models.TextField()
	articulo = models.ForeignKey(Articulo)
	class Admin:pass
	def __str__(self):
		return self.autor+"("+self.articulo.titulo+")"
# Create your models here.